<template>
  <div>
    <tree
      class="tree"
      ref="tree"
      v-model="modelTree"
      @tree:mounted="mounted($event)"
      :data="data"
      :filter="search"
      :options="treeOptions"
    >
      <div class="tree-scope" slot-scope="{ node }">
        <v-tooltip bottom>
          <template v-slot:activator="{ on, attrs }">
            <span class="text" v-bind="attrs" v-on="on">
              {{ node.text }}
            </span>
          </template>
          <template v-if="node.data.origen">
            <template v-if="node.data.origen !== 'usuario'">
              <span>Vista heredada de los perfiles {{ node.data.origen }}</span>
            </template>
            <template v-else>
              <span>Vista disponible</span>
            </template>
          </template>
          <template v-else>
            <span>Vista disponible</span>
          </template>
        </v-tooltip>
      </div>
    </tree>
  </div>
</template>
<style>
.tree-content.disabled .tree-checkbox {
  background-color: #aaaaab;
  border-color: #a7a8a9;
  cursor: auto;
}
.tree-size {
  overflow: auto;
  max-height: 440px;
  min-height: 440px;
}
</style>
<script>
const treeOptions = {
  filtering: true,
  propertyNames: {
    text: "nombre",
  },
  checkbox: true,
  filter: {
    emptyText: "Sin resultados",
    showChildren: false,
  },
};
export default {
  name: "Component-VistasUsuario",
  props: ["items", "values", "search"],
  data: () => ({
    data: [],
    allNodes: [],
    modelTree: null,
    nodeSelected: null,
    instanceTree: null,
  }),
  filters: {
    time(time) {
      return +time;
    },
  },
  watch: {
    modelTree(val) {
      let checkedNodes = val.checked;
      if (checkedNodes.length > 0) {
        let ids = [];
        checkedNodes.forEach((item) => {
          if (item.data && !item.states.disabled) {
            ids.push(item.id);
          }
        });
        this.$emit("input", ids);
      } else {
        this.$emit("input", []);
      }
    },
    values(val) {
      if (val.length > 0) {
        this.checkedNodes();
      }
    },
  },
  computed: {
    treeOptions() {
      return treeOptions;
    },
  },
  methods: {
    toVista(ruta) {
      return {
        name: ruta.nombre,
      };
    },
    mounted() {
      this.instanceTree = this.$refs.tree;
      this.getArbolVistas();
      if (this.values && this.values.length > 0) {
        this.checkedNodes();
      }
    },
    checkedNodes() {
      let nodes = this.instanceTree.findAll({});
      nodes.forEach((item) => {
        let vistaTemp = this.values.filter(
          (vista) => vista.idVista == item.id
        )[0];
        item.data = {
          ...item.data,
          ...vistaTemp,
        };
        let disabled =
          this.values.filter(
            (vista) => vista.idVista == item.id && vista.origen !== "usuario"
          ).length == 1;
        let checked =
          this.values.filter(
            (vista) =>
              vista.idVista == item.id &&
              item.children.length == 0 &&
              vista.origen === "usuario"
          ).length == 1;
        if (!disabled) {
          item.states.disabled = false;
        } else {
          item.states.checked = true;
        }
        if (checked) {
          item.check();
        }
        if (item.vm && disabled) {
          let element = item.vm.$el;
          let treeContent = element.getElementsByClassName("tree-content");
          treeContent[0].classList.add("disabled");
        }
      });
    },
    getArbolVistas() {
      let data = this.items.map((item, index) => {
        return {
          id: item.idVista,
          idParent: item.idVistaPadre,
          text: item.nombre,
          data: item,
          state: {
            expanded: true,
            disabled: true,
          },
        };
      });
      this.data = JSON.unflatten(data, "id", "idParent");
      this.data.forEach((item) => {
        this.instanceTree.append(item);
      });
    },
  },
};
</script>
